"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
__export(require('./implementations/command-impl'));
__export(require('./implementations/command-line-impl'));
__export(require('./implementations/progress-bar-impl'));
(function () {
    if (typeof console === 'undefined') {
        throw new Error('Weird, console object is undefined');
    }
    if (typeof console.table === 'function') {
        return;
    }
    var Table = require('easy-table');
    function arrayToString(arr) {
        var t = new Table();
        arr.forEach(function (record) {
            if (typeof record === 'string' ||
                typeof record === 'number') {
                t.cell('item', record);
            }
            else {
                Object.keys(record).forEach(function (property) {
                    t.cell(property, record[property]);
                });
            }
            t.newRow();
        });
        return t.toString();
    }
    function printTitleTable(title, arr) {
        var str = arrayToString(arr);
        var rowLength = str.indexOf('\n');
        if (rowLength > 0) {
            if (title.length > rowLength) {
                rowLength = title.length;
            }
            console.log(title);
            var sep = '-', k = void 0, line = '';
            for (k = 0; k < rowLength; k += 1) {
                line += sep;
            }
            console.log(line);
        }
        console.log(str);
    }
    function objectToArray(obj) {
        var keys = Object.keys(obj);
        return keys.map(function (key) {
            return {
                key: key,
                value: obj[key]
            };
        });
    }
    function objectToString(obj) {
        return arrayToString(objectToArray(obj));
    }
    console.table = function () {
        console.log('');
        var args = Array.prototype.slice.call(arguments);
        if (args.length === 2 &&
            typeof args[0] === 'string' &&
            Array.isArray(args[1])) {
            return printTitleTable(args[0], args[1]);
        }
        args.forEach(function (k) {
            if (typeof k === 'string') {
                return console.log(k);
            }
            else if (Array.isArray(k)) {
                console.log(arrayToString(k));
            }
            else if (typeof k === 'object') {
                console.log(objectToString(k));
            }
        });
    };
})();
//# sourceMappingURL=index.js.map